#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include "samory.h"


// options is a or of EXEC, SHLIB with CKPT
int checkpoint(struct command_mask *mask)
{
  int dev_fd, ret;

  dev_fd = open(DEVICE_NAME, O_RDONLY);
  if (dev_fd<0)
    return -1;

  ret = ioctl(dev_fd, CHECKPT, (int)mask);
  close(dev_fd);

  if (!ret)
  	return -2;
  return 1;
}


int restart(struct restart_param *param)
{
  int dev_fd, ret;

  dev_fd = open(DEVICE_NAME, O_RDONLY);
  if (dev_fd <0){
    printf("Unable to open device driver\n");
    return -1;
  }
  ret = ioctl(dev_fd, RESTART, (int)param);
  close(dev_fd);

  return ret;
}

/*
These functions work on sockets.
have_to_register tries to watch if the socket is owned by one of our processes
freeze looks in our process table if one
*/
int have_to_register(struct socket_cache_item *data){
  int dev_fd, ret, i;

  dev_fd = open(DEVICE_NAME, O_RDONLY);
  if (dev_fd <0){
    printf("Unable to open device driver\n");
    return -1;
  }

  ret = ioctl(dev_fd, SRCH, (int)data);
  close(dev_fd);

  return ret;
}


int freeze_socket(struct socket_cache_item *data){
  int dev_fd, ret;

  dev_fd = open(DEVICE_NAME, O_RDONLY);
  if (dev_fd <0)
    return 0;

  ret = ioctl(dev_fd, FRZSK, (int)data);
  close(dev_fd);

  return ret;
}

int unfreeze_socket(struct socket_cache_item *data)
{
  int dev_fd, ret;

  dev_fd = open(DEVICE_NAME, O_RDONLY);
  if (dev_fd <0)
    return -1;

  ret = ioctl(dev_fd, UFZSK, (int)data);
  close(dev_fd);

  return ret;
}

int xchange_sock(struct socket_cache_item *data)
{
  int dev_fd, ret;
	// we must return the new socket parameters in this structure
					// for registration in the buffers
  dev_fd = open(DEVICE_NAME, O_RDONLY);
  if (dev_fd <0)
    return -1;

  ret = ioctl(dev_fd, XCHSK, (int)data);
  close(dev_fd);
  return ret;
}
